const findOne = async ({
  inlineLedgerRunQuery,
  escapeId,
  escapeStr,
  tablePrefix,
  searchToWhereExpression,
  makeNestedPath,
  splitNestedPath,
  convertBinaryRow
}, readModelName, tableName, searchExpression, fieldList) => {
  const searchExpr = searchToWhereExpression(searchExpression, escapeId, escapeStr, makeNestedPath, splitNestedPath);
  const inlineSearchExpr = searchExpr.trim() !== '' ? `WHERE ${searchExpr} ` : '';
  const rows = await inlineLedgerRunQuery(`SELECT * FROM ${escapeId(`${tablePrefix}${tableName}`)}
    ${inlineSearchExpr}
    LIMIT 0, 1;`);

  if (Array.isArray(rows) && rows.length > 0) {
    return convertBinaryRow(rows[0], fieldList);
  }

  return null;
};

export default findOne;
//# sourceMappingURL=find-one.js.map