const MAX_LIMIT_VALUE = 0x0fffffff | 0;

const find = async ({
  inlineLedgerRunQuery,
  escapeId,
  escapeStr,
  tablePrefix,
  searchToWhereExpression,
  makeNestedPath,
  splitNestedPath,
  convertBinaryRow
}, readModelName, tableName, searchExpression, fieldList, sort, skip, limit) => {
  const orderExpression = sort && Object.keys(sort).length > 0 ? 'ORDER BY ' + Object.keys(sort).map(fieldName => {
    const [baseName, ...nestedPath] = splitNestedPath(fieldName);
    const provisionedName = nestedPath.length === 0 ? escapeId(baseName) : `${escapeId(baseName)}->'${makeNestedPath(nestedPath)}'`;
    return sort[fieldName] > 0 ? `${provisionedName} ASC` : `${provisionedName} DESC`;
  }).join(', ') : '';
  const skipLimit = `LIMIT ${isFinite(+skip) ? +skip : 0},${isFinite(+limit) ? +limit : MAX_LIMIT_VALUE}`;
  const searchExpr = searchToWhereExpression(searchExpression, escapeId, escapeStr, makeNestedPath, splitNestedPath);
  const inlineSearchExpr = searchExpr.trim() !== '' ? `WHERE ${searchExpr} ` : '';
  const inputRows = await inlineLedgerRunQuery(`SELECT * FROM ${escapeId(`${tablePrefix}${tableName}`)}
    ${inlineSearchExpr}
    ${orderExpression}
    ${skipLimit};`);
  const rows = [];

  for (let idx = 0; idx < inputRows.length; idx++) {
    rows[idx] = convertBinaryRow(inputRows[idx], fieldList);
  }

  return rows;
};

export default find;
//# sourceMappingURL=find.js.map