"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

const count = async ({
  inlineLedgerRunQuery,
  escapeId,
  escapeStr,
  tablePrefix,
  searchToWhereExpression,
  makeNestedPath,
  splitNestedPath
}, readModelName, tableName, searchExpression) => {
  const searchExpr = searchToWhereExpression(searchExpression, escapeId, escapeStr, makeNestedPath, splitNestedPath);
  const inlineSearchExpr = searchExpr.trim() !== '' ? `WHERE ${searchExpr} ` : '';
  const rows = await inlineLedgerRunQuery(`SELECT Count(*) AS Count FROM ${escapeId(`${tablePrefix}${tableName}`)}
    ${inlineSearchExpr};`);

  if (Array.isArray(rows) && rows.length > 0 && rows[0] != null && Number.isInteger(+rows[0].Count)) {
    return +rows[0].Count;
  }

  return 0;
};

var _default = count;
exports.default = _default;
//# sourceMappingURL=count.js.map